//+------------------------------------------------------------------+
//|                                    CheckStrategyTesterSpread.mq5 |
//|                                  Copyright 2013, Alain Verleyen. |
//|                     https://login.mql5.com/en/users/angevoyageur |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Alain Verleyen."
#property link      "https://login.mql5.com/en/users/angevoyageur"
#property version   "1.00"

struct SCheckSpread
  {
   datetime          checktime;
   int               spread1;       //- SymbolInfoDouble
   int               spread2;       //- SymbolInfoTick
   int               spread3;       //- MqlRates
   int               spread4;       //- CopySpread
  };

SCheckSpread spreads[];
int countValues=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   MqlRates rates[];
   int spreadBuffer[];
   int countDiscrepancy=0;

   for(int i=0;i<countValues;i++)
     {
      if(CopyRates(_Symbol,PERIOD_M1,spreads[i].checktime,1,rates)!=1) continue;
      spreads[i].spread3=rates[0].spread;

      if(CopySpread(_Symbol,PERIOD_M1,spreads[i].checktime,1,spreadBuffer)!=1) continue;
      spreads[i].spread4=spreadBuffer[0];

      if(spreads[i].spread1!=spreads[i].spread2
         || 
         spreads[i].spread1!=spreads[i].spread3
         || 
         spreads[i].spread1!=spreads[i].spread4)
        {
         countDiscrepancy++;
         Print("CHECK : time = ",spreads[i].checktime,
               " Spread 1 (SymbolInfoDouble) = ",spreads[i].spread1,
               " Spread 2 (SymbolInfoTick) = ",spreads[i].spread2,
               " Spread 3 (MqlRates) = ",spreads[i].spread3,
               " Spread 4 (CopySpread) = ", spreads[i].spread4
               );
        }
     }
   Print("Count discrepancy on spread for ",_Symbol," = ",countDiscrepancy," (on ",countValues," values)");

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(IsNewBar())
     {
      double ask=SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      double bid=SymbolInfoDouble(_Symbol,SYMBOL_BID);
      double spread1=ask-bid;

      countValues++;
      if(ArrayResize(spreads,countValues,1000)==-1) return;
      spreads[countValues-1].checktime=TimeCurrent();
      spreads[countValues-1].spread1=(int)MathRound(spread1/_Point);

      MqlTick tick;
      if(!SymbolInfoTick(_Symbol,tick)) return;
      double spread2=tick.ask-tick.bid;
      spreads[countValues-1].spread2=(int)MathRound(spread2/_Point);
     }
  }
//+------------------------------------------------------------------+
//| Check for a new bar on current symbol and timeframe              |
//+------------------------------------------------------------------+
bool IsNewBar()
  {
   static datetime _LastBarOpenTime;

   bool _isBarsChanged=false;
   datetime _barOpenTime[];

   if(CopyTime(NULL,PERIOD_CURRENT,0,1,_barOpenTime))
     {
      if(_barOpenTime[0]!=_LastBarOpenTime)
        {
         _isBarsChanged=true;
         _LastBarOpenTime=_barOpenTime[0];
        }
     }

   return(_isBarsChanged);
  }
//+------------------------------------------------------------------+
